
/*  BL_std.h   >
                                                                        
     Program:                                                           
                                                                        
     Module:           BL_std.h                                         
                                                                        
     Abstract: C Header for all standard Programs                       
                                                                        
     Author:   Benjamin Lear (BL)                                       
                                                                        
     Date: 			31.5.1993                                
                                                                        
     Last modified: 31.5.1993                                           
                                                                        
         */

/*  DESCRIPTION   >
                                                                        
         */

/*  HISTORY  >
                                                                        
         */


#ifndef _BL_STD_H
#define _BL_STD_H 1

/*     ------------------  Standard - Header ---------------------      */

#ifdef BL_STD

#include <stdio.h>
#include <stdlib.h>
#include <stddef.h>

#include <ctype.h>
#include <string.h>

/*                                
   system dependend:
*/


#include <exec/types.h>
#include <exec/lists.h>
#include <exec/memory.h>

#endif /* BL_STD */

/*                       MATHS 
*/

#ifdef BL_MATH

#include <BL_math.h>

#endif /* BL_MATH */


/*      ----------------------  intuition  ----------------------      */

#ifdef BL_INTUITION


#include <utility/tagitem.h>
#include <intuition/screens.h>

#include <intuition/intuition.h>
#include <intuition/gadgetclass.h>
#include <libraries/gadtools.h>


#endif /* BL_INTUITION */

/*        -------------------  PROTOTYPES  -----------------------      */


#ifdef BL_PROTOS

#include <clib/exec_protos.h>
/*#include <clib/graphics_protos.h>*/
#include <clib/intuition_protos.h>
#include <clib/gadtools_protos.h>

#endif

/*                          
*/

#ifdef BL_MY_PROTOS

#endif

/*   --------------------------  Macros  --------------------------     //

/*                     Debuging  
*/

#ifdef BL_DEBUG

  #ifndef DB
    #define DB(a) printf("File: %s Line: %d -> %s\n",__FILE__,__LINE__, a )
  #endif

  #ifndef DBX
    #define DBX(s,n,f) printf("File: %s Line: %d -> %s, %d, % .13e \n",__FILE__,__LINE__, s,n,f )
  #endif

#else
  #ifndef BL_DEBUG

    #define DB(a)
    #define DBX(s,n,f)

  #endif

#endif /* BL_DEBUG


#endif /* BL_STD_H */

/*                           THE  END                           
*/

